主頁 > 知識庫 > Linux系統(tǒng)上配置Nginx+Ruby on Rails+MySQL超攻略

Linux系統(tǒng)上配置Nginx+Ruby on Rails+MySQL超攻略

熱門標(biāo)簽:湖州u友防封電銷卡 地圖標(biāo)注賺錢項(xiàng)目注冊 百度地圖標(biāo)注自定義圖片 常德電銷平臺外呼系統(tǒng)軟件價(jià)格 白銀外呼paas系統(tǒng) 電銷機(jī)器人廠商代理 高德地圖標(biāo)注客服 滴滴外呼系統(tǒng) 徐州網(wǎng)絡(luò)外呼系統(tǒng)哪個(gè)好

安裝 RVM

通常使用 RVM 或 rbenv 來安裝 Ruby,這里選用 RVM。

$ curl -sSL https://get.rvm.io | bash -s stable

載入 RVM :

$ source /home/libuchao/.rvm/scripts/rvm
$ rvm -v
rvm 1.25.12 (stable) by Wayne E. Seguin wayneeseguin@gmail.com> ......

再執(zhí)行以下命令:

$ type rvm
rvm is a function
......

說明 RVM 安裝正確。
安裝 Ruby

用 RVM 安裝 Ruby

$ rvm install 2.1.0
$ rvm use 2.1.0 --default
$ ruby -v
ruby 2.1.0p0

國內(nèi)服務(wù)器推薦替換 RubyGems 的到淘寶鏡像

$ gem sources -r https://rubygems.org/
$ gem sources -a http://ruby.taobao.org/

否則安裝 Gem 可能會非常非常慢。
安裝 Rails

其實(shí) Rails 也是一個(gè) Gem

$ gem install rails --no-ri --no-rdoc -V
......
$ rails -v
Rails 4.0.2

至此,Rails 環(huán)境已經(jīng)安裝完成。
安裝 MySQL

安裝 Mysql 及相應(yīng)的庫文件:

$ sudo apt-get install mysql-server libmysqlclient-dev

然后進(jìn)行一些安裝方面的設(shè)置:

$ /usr/bin/mysql_secure_installation

創(chuàng)建相應(yīng)的數(shù)據(jù)庫,并為它新建一個(gè)權(quán)限小一些的用戶:

mysql> CREATE DATABASE blix_production;
mysql> GRANT ALL PRIVILEGES ON blix_production.* TO blix@localhost IDENTIFIED BY "123456";
mysql> flush privileges;
mysql> exit

導(dǎo)入數(shù)據(jù):

$ mysql -u blix -p blix_production  database.sql

安裝 Nginx

Nginx 專門處理靜態(tài)請求,并作為 Unicorn 的反向代理

編輯 /etc/apt/sources.list,末尾處添加以下兩行

deb http://nginx.org/packages/ubuntu/ precise nginx
deb-src http://nginx.org/packages/ubuntu/ precise nginx

添加 Nginx 簽名

$ wget http://nginx.org/keys/nginx_signing.key
$ sudo apt-key add nginx_signing.key

安裝 Nginx

$ sudo apt-get update
$ sudo apt-get install nginx

安裝完成后可以在瀏覽器中輸入 http://server-ipaddress 查看是否安裝正確。
配置 Unicorn

首先編譯一下靜態(tài)文件:

$ RAILS_ENV=production rake assets:clean
$ RAILS_ENV=production rake assets:precompile

Unicorn 配置參考:

worker_processes 2
timeout 30

APP_PATH = File.expand_path("../..", __FILE__)
working_directory APP_PATH

listen 8080, :tcp_nopush => true
listen "/tmp/unicorn.sock", :backlog => 64

stderr_path APP_PATH + "/log/unicorn.stderr.log"
stdout_path APP_PATH + "/log/unicorn.stdout.log"

pid APP_PATH + "/tmp/pids/unicorn.pid"

Unicorn 自啟動腳本:

#!/bin/sh
set -e
# Example init script, this can be used with nginx, too,
# since nginx and unicorn accept the same signals

# Feel free to change any of the following variables for your app:
TIMEOUT=${TIMEOUT-60}
APP_ROOT=/home/libuchao/blix
APP_USER=libuchao
PID=$APP_ROOT/tmp/pids/unicorn.pid
CMD="unicorn_rails -D -E production -c $APP_ROOT/config/unicorn.rb"
action="$1"
set -u

old_pid="$PID.oldbin"

cd $APP_ROOT || exit 1

sig () {
    test -s "$PID"  kill -$1 `cat $PID`
}

oldsig () {
    test -s $old_pid  kill -$1 `cat $old_pid`
}

case $action in
start)
    sig 0  echo >2 "Already running"  exit 0
    su -c "$CMD" - $APP_USER
    ;;
stop)
    sig QUIT  exit 0
    echo >2 "Not running"
    ;;
force-stop)
    sig TERM  exit 0
    echo >2 "Not running"
    ;;
restart|reload)
    sig HUP  echo reloaded OK  exit 0
    echo >2 "Couldn't reload, starting '$CMD' instead"
    su -c "$CMD" - $APP_USER
    ;;
upgrade)
    if sig USR2  sleep 2  sig 0  oldsig QUIT
    then
        n=$TIMEOUT
        while test -s $old_pid  test $n -ge 0
        do
            printf '.'  sleep 1  n=$(( $n - 1 ))
        done
        echo

        if test $n -lt 0  test -s $old_pid
        then
            echo >2 "$old_pid still exists after $TIMEOUT seconds"
            exit 1
        fi
        exit 0
    fi
    echo >2 "Couldn't upgrade, starting '$CMD' instead"
    su -c "$CMD" - $APP_USER
    ;;
reopen-logs)
    sig USR1
    ;;
*)
    echo >2 "Usage: $0 start|stop|restart|upgrade|force-stop|reopen-logs>"
    exit 1
    ;;
esac

將這個(gè) shell 在/etc/init.d/下做一個(gè)軟連接,并使其開機(jī)自啟動:

$ chmod +x /home/libuchao/blix/config/unicorn_init.sh
$ sudo ln -s /home/libuchao/blix/config/unicorn_init.sh /etc/init.d/unicorn
$ sudo update-rc.d unicorn defaults

啟動 Unicorn:

$ service unicorn start

在瀏覽器中輸入 http://server_ipaddress:8080 查看效果。
配置 Nginx

Nginx 配置參考:

upstream blix_backend {
  server unix:/tmp/unicorn.sock fail_timeout=0;
}

gzip on;
gzip_disable "msie6";
client_max_body_size 150m;

server {
  listen 80 default;
  return 403;
}

server {
  listen 80;
  server_name libuchao.com www.libuchao.com;

  root /home/libuchao/blix/public;

  try_files $uri/index.html $uri.html $uri @httpapp;

  location @httpapp {
    proxy_redirect   off;
    proxy_set_header  Host $host;
    proxy_set_header  X-Forwarded-Host $host;
    proxy_set_header  X-Forwarded-Server $host;
    proxy_set_header  X-Real-IP    $remote_addr;
    proxy_set_header  X-Forwarded-For $proxy_add_x_forwarded_for;
    proxy_buffering  on;

    proxy_pass http://blix_backend;
  }

  location ~ ^(/assets) {
    access_log off;
    expires   max;
  }
}

此時(shí)應(yīng)該可以通過域名直接訪問了。

您可能感興趣的文章:
  • CentOS7下搭建ruby on rails開發(fā)環(huán)境
  • CentOS中配置Ruby on Rails環(huán)境
  • 在 Ubuntu 12.04 Server 上安裝部署 Ruby on Rails 應(yīng)用
  • Ubuntu上配置Ruby on Rails框架及RubyMine IDE開發(fā)環(huán)境

標(biāo)簽:普洱 永州 張家界 梧州 荊門 公主嶺 遼寧 三沙

巨人網(wǎng)絡(luò)通訊聲明:本文標(biāo)題《Linux系統(tǒng)上配置Nginx+Ruby on Rails+MySQL超攻略》,本文關(guān)鍵詞  Linux,系統(tǒng),上,配置,Nginx+Ruby,;如發(fā)現(xiàn)本文內(nèi)容存在版權(quán)問題,煩請?zhí)峁┫嚓P(guān)信息告之我們,我們將及時(shí)溝通與處理。本站內(nèi)容系統(tǒng)采集于網(wǎng)絡(luò),涉及言論、版權(quán)與本站無關(guān)。
  • 相關(guān)文章
  • 下面列出與本文章《Linux系統(tǒng)上配置Nginx+Ruby on Rails+MySQL超攻略》相關(guān)的同類信息!
  • 本頁收集關(guān)于Linux系統(tǒng)上配置Nginx+Ruby on Rails+MySQL超攻略的相關(guān)信息資訊供網(wǎng)民參考!
  • 推薦文章